/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.math.BigInteger;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.server.UnicastRemoteObject;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Thomas
 */
public class Server extends UnicastRemoteObject implements ICommon {

    private String username = "";
    private String password = "";
    private BigInteger challenge;

    public Server() throws java.rmi.RemoteException, Exception {

        try {
            // Register the server with the naming service.
            LocateRegistry.createRegistry(ICommon.port);
            Naming.rebind("rmi://localhost:" + ICommon.port + "/" + ICommon.serviceName, this);
            System.out.println("Server started on port " + ICommon.port);
            System.out.println();

            Scanner in = new Scanner(System.in);
            System.out.println("Define Username:");
            this.username = in.nextLine();

            System.out.println("Define Password:");
            this.password = in.nextLine();
            in.close();
            System.out.println();
            //System.out.println("Waiting for incoming connections...");
        } catch (Exception e) {
            throw e;
        }
    }

    public BigInteger challenge() throws RemoteException, NoSuchAlgorithmException {
        try {


            // Create a secure random number generator
            SecureRandom sr = SecureRandom.getInstance("SHA1PRNG");

            // Get 1024 random bits
            byte[] bytes = new byte[1024 / 8];
            sr.nextBytes(bytes);
            this.challenge = BigInteger.valueOf(sr.nextLong());

            System.out.println("==================================================");
            System.out.println("Created challenge:");
            System.out.println(challenge);
            try {
                Thread.sleep(1000);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            return this.challenge;
        } catch (NoSuchAlgorithmException e) {
            throw e;
        }
    }

    public boolean response(BigInteger responseFromClient) throws RemoteException {
        try {
            BigInteger expectedResponse = Utils.generateResponse(username, password, challenge);
            System.out.println();
            System.out.println("Comparing responses:");
            System.out.println("Received response = " + responseFromClient);
            System.out.println("Expected response = " + expectedResponse);
            System.out.println();
            if (expectedResponse.equals(responseFromClient)) {
                //Login successful
                System.out.println("Login success: " + true);
                System.out.println("==================================================");
                System.out.println();
                System.out.println();
                System.out.println();
                System.out.println();
                System.out.println();
                System.out.println();
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
                return true;
            } else {
                //Login failed
                System.out.println("Login success: " + false);
                System.out.println("==================================================");
                System.out.println();
                System.out.println();
                System.out.println();
                System.out.println();
                System.out.println();
                System.out.println();
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
                return false;
            }
        } catch (NoSuchAlgorithmException ex) {
            return false;
        }
    }
}
